## ffmpeg 4.1.9.5

=== libavdevice/Makefile ===
NAME    = avdevice
DESC    = FFmpeg device handling library

HEADERS = avdevice.h                                                    \
          version.h                                                     \

OBJS    = alldevices.o                                                  \
          avdevice.o                                                    \
          utils.o                                                       \

OBJS-$(HAVE_LIBC_MSVCRT)                 += file_open.o
OBJS-$(CONFIG_SHARED)                    += reverse.o

# input/output devices
OBJS-$(CONFIG_ALSA_INDEV)                += alsa_dec.o alsa.o timefilter.o
OBJS-$(CONFIG_ALSA_OUTDEV)               += alsa_enc.o alsa.o
OBJS-$(CONFIG_ANDROID_CAMERA_INDEV)      += android_camera.o
OBJS-$(CONFIG_AVFOUNDATION_INDEV)        += avfoundation.o
OBJS-$(CONFIG_BKTR_INDEV)                += bktr.o
OBJS-$(CONFIG_CACA_OUTDEV)               += caca.o
OBJS-$(CONFIG_DECKLINK_OUTDEV)           += decklink_enc.o decklink_enc_c.o decklink_common.o
OBJS-$(CONFIG_DECKLINK_INDEV)            += decklink_dec.o decklink_dec_c.o decklink_common.o
OBJS-$(CONFIG_LIBNDI_NEWTEK_OUTDEV)      += libndi_newtek_enc.o
OBJS-$(CONFIG_LIBNDI_NEWTEK_INDEV)       += libndi_newtek_dec.o
OBJS-$(CONFIG_DSHOW_INDEV)               += dshow_crossbar.o dshow.o dshow_enummediatypes.o \
                                            dshow_enumpins.o dshow_filter.o \
                                            dshow_pin.o dshow_common.o
OBJS-$(CONFIG_FBDEV_INDEV)               += fbdev_dec.o \
                                            fbdev_common.o
OBJS-$(CONFIG_FBDEV_OUTDEV)              += fbdev_enc.o \
                                            fbdev_common.o
OBJS-$(CONFIG_GDIGRAB_INDEV)             += gdigrab.o
OBJS-$(CONFIG_IEC61883_INDEV)            += iec61883.o
OBJS-$(CONFIG_JACK_INDEV)                += jack.o timefilter.o
OBJS-$(CONFIG_KMSGRAB_INDEV)             += kmsgrab.o
OBJS-$(CONFIG_LAVFI_INDEV)               += lavfi.o
OBJS-$(CONFIG_OPENAL_INDEV)              += openal-dec.o
OBJS-$(CONFIG_OPENGL_OUTDEV)             += opengl_enc.o
OBJS-$(CONFIG_OSS_INDEV)                 += oss_dec.o oss.o
OBJS-$(CONFIG_OSS_OUTDEV)                += oss_enc.o oss.o
OBJS-$(CONFIG_PULSE_INDEV)               += pulse_audio_dec.o \
                                            pulse_audio_common.o timefilter.o
OBJS-$(CONFIG_PULSE_OUTDEV)              += pulse_audio_enc.o \
                                            pulse_audio_common.o
OBJS-$(CONFIG_SDL2_OUTDEV)               += sdl2.o
OBJS-$(CONFIG_SNDIO_INDEV)               += sndio_dec.o sndio.o
OBJS-$(CONFIG_SNDIO_OUTDEV)              += sndio_enc.o sndio.o
OBJS-$(CONFIG_V4L2_INDEV)                += v4l2.o v4l2-common.o timefilter.o
OBJS-$(CONFIG_V4L2_OUTDEV)               += v4l2enc.o v4l2-common.o
OBJS-$(CONFIG_VFWCAP_INDEV)              += vfwcap.o
OBJS-$(CONFIG_XCBGRAB_INDEV)             += xcbgrab.o
OBJS-$(CONFIG_XV_OUTDEV)                 += xv.o

# external libraries
OBJS-$(CONFIG_LIBCDIO_INDEV)             += libcdio.o
OBJS-$(CONFIG_LIBDC1394_INDEV)           += libdc1394.o

# Windows resource file
SLIBOBJS-$(HAVE_GNU_WINDRES)             += avdeviceres.o

SKIPHEADERS                              += decklink_common.h
SKIPHEADERS-$(CONFIG_DECKLINK)           += decklink_enc.h decklink_dec.h \
                                            decklink_common_c.h
SKIPHEADERS-$(CONFIG_LIBNDI_NEWTEK_INDEV) += libndi_newtek_common.h
SKIPHEADERS-$(CONFIG_LIBNDI_NEWTEK_OUTDEV) += libndi_newtek_common.h
SKIPHEADERS-$(CONFIG_DSHOW_INDEV)        += dshow_capture.h
SKIPHEADERS-$(CONFIG_FBDEV_INDEV)        += fbdev_common.h
SKIPHEADERS-$(CONFIG_FBDEV_OUTDEV)       += fbdev_common.h
SKIPHEADERS-$(CONFIG_LIBPULSE)           += pulse_audio_common.h
SKIPHEADERS-$(CONFIG_V4L2_INDEV)         += v4l2-common.h
SKIPHEADERS-$(CONFIG_V4L2_OUTDEV)        += v4l2-common.h
SKIPHEADERS-$(CONFIG_ALSA)               += alsa.h
SKIPHEADERS-$(CONFIG_SNDIO)              += sndio.h

TESTPROGS-$(CONFIG_JACK_INDEV)           += timefilter

=== libavutil/arm/Makefile ===
OBJS += arm/cpu.o                                                       \
        arm/float_dsp_init_arm.o                                        \

VFP-OBJS += arm/float_dsp_init_vfp.o                                    \
            arm/float_dsp_vfp.o                                         \

NEON-OBJS += arm/float_dsp_init_neon.o                                  \
             arm/float_dsp_neon.o                                       \

=== libavutil/mips/Makefile ===
OBJS += mips/float_dsp_mips.o

=== libswscale/x86/Makefile ===
$(SUBDIR)x86/swscale_mmx.o: CFLAGS += $(NOREDZONE_FLAGS)

OBJS                            += x86/rgb2rgb.o                        \
                                   x86/swscale.o                        \
                                   x86/yuv2rgb.o                        \

MMX-OBJS                        += x86/hscale_fast_bilinear_simd.o      \

OBJS-$(CONFIG_XMM_CLOBBER_TEST) += x86/w64xmmtest.o

X86ASM-OBJS                     += x86/input.o                          \
                                   x86/output.o                         \
                                   x86/scale.o                          \
                                   x86/rgb_2_rgb.o                      \

=== debian/changelog ===
ffmpeg (7:4.1.9.5-deepin5) unstable; urgency=low

  * fix: CVE-2020-20450

 -- fengli <fengli@uniontech.com>  Wed, 24 Aug 2022 16:58:30 +0800

ffmpeg (7:4.1.9.4-1+dde) unstable; urgency=low

  * fix: CVE-2020-22039   CVE-2020-22044  CVE-2020-21697

 -- fengli <fengli@uniontech.com>  Tue, 9 Aug 2022 16:11:30 +0800

ffmpeg (7:4.1.9.3-1+dde) unstable; urgency=low                                         
                                                                                        
  * fix: xd patch 4.1.9 version                                            
                                                                                        
 -- muyuankai <muyuankai@uniontech.com>  Tue, 19 Jul 2022 10:20:30 +0800

ffmpeg (7:4.1.9.2-1+dde) unstable; urgency=low                                         
                                                                                        
  * fix: merge hisi patch 4.1.9 version                                            
                                                                                        
 -- muyuankai <muyuankai@uniontech.com>  Mon, 18 Jul 2022 10:20:30 +0800

ffmpeg (7:4.1.9.1-1+dde) unstable; urgency=low                                         
                                                                                        
  * fix: merge new upstream 4.1.9 version                                            
                                                                                        
 -- fengli <fengli@uniontech.com>  Mon, 11 Jul 2022 15:20:30 +0800
 

ffmpeg (7:4.1.8.11-1+dde) unstable; urgency=low                                         
                                                                                        
  * fix: ffmpeg 4.1.8  hisi patch                                            
                                                                                        
 -- muyuankai <muyuankai@uniontech.com>  Fri, 1 Jul 2022 10:22:30 +0800

ffmpeg (7:4.1.8.10-1+dde) unstable; urgency=low                                         
                                                                                        
  * fix: ffmpeg 4.1.8  nvenc                                            
                                                                                        
 -- muyuankai <muyuankai@uniontech.com>  Mon, 14 Mar 2022 15:22:30 +0800

ffmpeg (7:4.1.8.9-1+dde) unstable; urgency=low                                         
                                                                                        
  * fix CVE-2020-20451 CVE-2020-20891 CVE-2020-20892  CVE-2020-20896                                             
                                                                                        
 -- fengli <fengli@uniontech.com>  Mon, 07 Mar 2022 10:39:30 +0800

ffmpeg (7:4.1.8.8-1+dde) unstable; urgency=low                                         
                                                                                        
  * fix CVE-2020-20898
        CVE-2021-38094
        CVE-2021-38093
        CVE-2021-38092
        CVE-2021-38091
        CVE-2021-38090
        
 -- fengli <fengli@uniontech.com>  Tue, 1 Mar 2022 15:51:30 +0800

ffmpeg (7:4.1.8.7-1+dde) unstable; urgency=low                                         
                                                                                        
  * remove patch: fix ft-x100 patch                                               
                                                                                        
 -- hemingyang <hemingyang@uniontech.com>  Wed, 23 Feb 2022 10:35:30 +0800

ffmpeg (7:4.1.8.6-1+dde) unstable; urgency=low                                         
                                                                                        
  * fix: fix ft-x100 patch                                               
                                                                                        
 -- zhuyuliang <zhuyuliang@uniontech.com>  Fri, 26 Jan 2022 15:30:30 +0800

ffmpeg (7:4.1.8.5-1+dde) unstable; urgency=low

  * fix: fix do not read undersized frames of pulse

 -- hemingyang <hemingyang@uniontech.com>  Fri, 14 Jan 2022 10:30:30 +0800

ffmpeg (7:4.1.8.4-1+dde) unstable; urgency=low                                         
                                                                                        
  * Add loongson 5000  patch                                               
                                                                                        
 -- muyuankai <muyuankai@uniontech.com>  Tue, 04 Jan 2022 13:30:30 +0800

ffmpeg (7:4.1.8.3-1+dde) unstable; urgency=low                                         
                                                                                        
  * Add ft x100 omx hwaccel support                                                
                                                                                        
 -- zhuyuliang <zhuyuliang@uniontech.com>  Fri, 31 Dec 2021 13:30:30 +0800

ffmpeg (7:4.1.8.2-1+dde) unstable; urgency=low                                         
                                                                                        
  * fix:add avs2  for ffmpeg 4.1.8                                                 
                                                                                        
 -- muyuankai <muyuankai@uniontech.com>  Fri, 26 Nov 2021 15:22:30 +0800

ffmpeg (7:4.1.8.1-1+dde) unstable; urgency=low                                         
                                                                                        
  * fix:update 4.1.6 patch                                                   
                                                                                        
 -- muyuankai <muyuankai@uniontech.com>  Thu, 10 Oct 2021 15:22:30 +0800

=== debian/control ===
Source: ffmpeg
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Andreas Cadhalpun <Andreas.Cadhalpun@googlemail.com>,
 Alexander Strasser <eclipse7@gmx.net>,
 Reinhard Tartler <siretart@tauware.de>,
 Balint Reczey <balint@balintreczey.hu>,
 James Cowgill <jcowgill@debian.org>
Rules-Requires-Root: no
Homepage: https://ffmpeg.org/
Standards-Version: 4.2.1
Vcs-Git: https://salsa.debian.org/multimedia-team/ffmpeg.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/ffmpeg
Build-Depends-Indep:
# needed to minify the CSS files
 cleancss,
# Autogenerated documentation
 doxygen,
# needed to create the CSS files for the HTML manuals
 node-less
Build-Depends:
# needed for dh
 debhelper (>= 11~),
# for build-profile support
 dpkg-dev (>= 1.17.14),
# --enable-libflite
 flite1-dev,
# --enable-frei0r
 frei0r-plugins-dev <!pkg.ffmpeg.stage1>,
# --enable-ladspa
 ladspa-sdk,
# --enable-libaom
 libaom-dev,
# --enable-libass
 libass-dev,
# --enable-libbluray
 libbluray-dev,
# --enable-libbs2b
 libbs2b-dev,
# autodetected: external library 'bzlib'
 libbz2-dev,
# --enable-libcaca
 libcaca-dev,
# --enable-libcdio
 libcdio-paranoia-dev,
# --enable-libchromaprint
 libchromaprint-dev <!pkg.ffmpeg.stage1>,
# --enable-libcodec2
 libcodec2-dev,
# autodetected 'crystalhd'
 libcrystalhd-dev [amd64 i386],
# --enable-libdc1394
 libdc1394-22-dev [linux-any],
# --enable-libdrm
 libdrm-dev [linux-any],
# --enable-libfontconfig
 libfontconfig1-dev,
# --enable-libfreetype
 libfreetype6-dev,
# --enable-fribidi
 libfribidi-dev,
# --enable-opengl
 libgl1-mesa-dev,
# --enable-libgme
 libgme-dev,
# --enable-gnutls
 libgnutls28-dev,
# --enable-libgsm
 libgsm1-dev,
# Fails to be detected by configure script, if not also libavc1394-dev is installed.
# --enable-libiec61883
 libiec61883-dev [linux-any],
 libavc1394-dev [linux-any],
# --enable-libjack
 libjack-jackd2-dev,
# --enable-liblensfun (used only in -extra flavor)
 liblensfun-dev,
# --enable-lv2
 liblilv-dev,
# autodetected for the tiff decoder
 liblzma-dev,
# --enable-libmp3lame
 libmp3lame-dev,
# --enable-libmysofa
 libmysofa-dev,
# --enable-openal
 libopenal-dev,
# --enable-omx
 libomxil-bellagio-dev,
# --enable-libopencore_amrnb
 libopencore-amrnb-dev,
# --enable-libopencore_amrwb
 libopencore-amrwb-dev,
# --enable-libopenjpeg
 libopenjp2-7-dev (>= 2.1),
# --enable-libopenmpt
 libopenmpt-dev,
# --enable-libopus
 libopus-dev,
# --enable-libpulse
 libpulse-dev,
# --enable-librubberband
 librubberband-dev,
# --enable-librsvg
 librsvg2-dev,
# autodetected: protocol 'sctp'
 libsctp-dev [linux-any],
# --enable-sdl2
 libsdl2-dev,
# --enable-libshine
 libshine-dev (>= 3.0.0),
# --enable-libsnappy
 libsnappy-dev,
# --enable-libsoxr
 libsoxr-dev,
# --enable-libspeex
 libspeex-dev,
# --enable-libssh
 libssh-gcrypt-dev,
# --enable-libtesseract (used only in -extra flavor)
 libtesseract-dev,
# --enable-libtheora
 libtheora-dev,
# --enable-libtwolame
 libtwolame-dev,
# This is not necessary, see explanation in debian/rules.
# # --enable-libv4l2
# libv4l-dev [!hurd-any],
# autodetected: hwaccels 'h263_vaapi, mpeg2_vaapi, vc1_vaapi, h264_vaapi, mpeg4_vaapi, wmv3_vaapi'
 libva-dev (>= 1.3) [!hurd-any],
# autodetected: hwaccels 'h263_vdpau, mpeg2_vdpau, vc1_vdpau, h264_vdpau, mpeg4_vdpau, wmv3_vdpau, mpeg1_vdpau', decoders 'h264_vdpau, mpeg1_vdpau, mpeg4_vdpau, mpeg_vdpau, vc1_vdpau, wmv3_vdpau'
 libvdpau-dev,
# --enable-libvidstab
 libvidstab-dev,
# --enable-libvo_amrwbenc
 libvo-amrwbenc-dev,
# --enable-libvorbis
 libvorbis-dev,
# --enable-libvpx
 libvpx-dev,
# --enable-libwavpack
 libwavpack-dev,
# --enable-libwebp
 libwebp-dev,
# --enable-libx264
 libx264-dev <!pkg.ffmpeg.stage1>,
# --enable-libx265
 libx265-dev (>= 1.8),
# autodetected libxcb-shape
 libxcb-shape0-dev,
# autodetected libxcb-shm
 libxcb-shm0-dev,
# autodetected libxcb-xfixes
 libxcb-xfixes0-dev,
# --enable-libxml2
 libxml2-dev,
# autodetected xlib
 libxv-dev,
# --enable-libxvid
 libxvidcore-dev,
# autodetected: decoder 'mpeg_xvmc'; outdev 'xv'
 libxvmc-dev,
# --enable-libzmq
 libzmq3-dev,
# --enable-libzvbi
 libzvbi-dev,
# The opencl API is considered experimental.
# # --enable-opencl
# ocl-icd-opencl-dev [!hurd-any] | opencl-dev [!hurd-any],
# used to detect libraries
 pkg-config,
# HTML documentation
 texinfo,
# assembler optimizations
 nasm,
 libffmpeg-nvenc-dev [amd64],
 nvidia-cuda-dev [amd64],
# autodetected zlib
 zlib1g-dev,
# --enable-libdavs2
 libdavs2-dev,
# --enable-libxavs2
 libxavs2-dev

Package: ffmpeg
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Suggests:
 ffmpeg-doc
Breaks: libav-tools (<< 6:12~~),
 qt-faststart (<< 7:2.7.1-3~),
 winff (<< 1.5.5-5~),
Replaces: libav-tools (<< 6:12~~),
 qt-faststart (<< 7:2.7.1-3~)
Description: Tools for transcoding, streaming and playing of multimedia files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This package contains:
  * ffmpeg: a command line tool to convert multimedia files between formats
  * ffplay: a simple media player based on SDL and the FFmpeg libraries
  * ffprobe: a simple multimedia stream analyzer
  * qt-faststart: a utility to rearrange Quicktime files

Package: ffmpeg-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 libjs-bootstrap,
 ${misc:Depends}
Description: Documentation of the FFmpeg multimedia framework
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This package contains the HTML documentation for the FFmpeg multimedia
 framework including the API documentation created by doxygen and the manpages
 for the libraries.

Package: libavcodec58
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: FFmpeg library with de/encoders for audio/video codecs - runtime files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic encoding/decoding framework and
 contains multiple decoders and encoders for audio, video and subtitle streams,
 and several bitstream filters.
 .
 The shared architecture provides various services ranging from bit stream I/O
 to DSP optimizations, and makes it suitable for implementing robust and fast
 codecs as well as for experimentation.
 .
 This package contains the runtime files.

Package: libavcodec-extra58
Architecture: any
Section: libs
Multi-Arch: same
Conflicts: libavcodec58
Provides:
 libavcodec58 (= ${binary:Version}),
 libavcodec-extra
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: FFmpeg library with additional de/encoders for audio/video codecs
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic encoding/decoding framework and
 contains multiple decoders and encoders for audio, video and subtitle streams,
 and several bitstream filters.
 .
 The shared architecture provides various services ranging from bit stream I/O
 to DSP optimizations, and makes it suitable for implementing robust and fast
 codecs as well as for experimentation.
 .
 This package replaces the libavcodec58 package and contains the
 following additional codecs:
 .
  * OpenCORE Adaptive Multi-Rate (AMR) Narrow-Band (Encoder/Decoder)
  * OpenCORE Adaptive Multi-Rate (AMR) Wide-Band (Decoder)
  * Android VisualOn Adaptive Multi-Rate (AMR) Wide-Band (Encoder)
 .
 Because this package links against libraries that are licensed under
 Apache License 2.0, the resulting binaries are distributed under the
 GPL version 3 or later.

Package: libavcodec-extra
Architecture: all
Section: metapackages
Multi-Arch: foreign
Depends:
 libavcodec-extra58,
 ${misc:Depends}
Description: FFmpeg library with extra codecs (metapackage)
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This metapackage depends on the latest version of the libavcodec variant
 that offers additional codec support. Application packages can depend
 on it if they require or suggest this variant in a robust manner.


Package: libavcodec-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libavcodec58 (= ${binary:Version}),
 libavutil-dev (= ${binary:Version}),
 libswresample-dev (= ${binary:Version}),
 ${misc:Depends}
Description: FFmpeg library with de/encoders for audio/video codecs - development files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic encoding/decoding framework and
 contains multiple decoders and encoders for audio, video and subtitle streams,
 and several bitstream filters.
 .
 The shared architecture provides various services ranging from bit stream I/O
 to DSP optimizations, and makes it suitable for implementing robust and fast
 codecs as well as for experimentation.
 .
 This package contains the development files.

Package: libavdevice58
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: FFmpeg library for handling input and output devices - runtime files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic framework for grabbing from and rendering to
 many common multimedia input/output devices, and supports several input and
 output devices, including Video4Linux2, VfW, DShow, and ALSA.
 .
 This package contains the runtime files.

Package: libavdevice-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libavcodec-dev (= ${binary:Version}),
 libavdevice58 (= ${binary:Version}),
 libavfilter-dev (= ${binary:Version}),
 libavformat-dev (= ${binary:Version}),
 libavutil-dev (= ${binary:Version}),
 libpostproc-dev (= ${binary:Version}),
 libswscale-dev (= ${binary:Version}),
 libswresample-dev (= ${binary:Version}),
 ${misc:Depends}
Description: FFmpeg library for handling input and output devices - development files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic framework for grabbing from and rendering to
 many common multimedia input/output devices, and supports several input and
 output devices, including Video4Linux2, VfW, DShow, and ALSA.
 .
 This package contains the development files.

Package: libavfilter7
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: FFmpeg library containing media filters - runtime files

=== debian/rules ===
#!/usr/bin/make -f

export V=1

export DEB_BUILD_OPTIONS=nocheck

# sets DEBIAN_VERSION variable
include /usr/share/dpkg/pkg-info.mk

# Get the Debian version revision:
DEB_REVISION := $(word 2, $(subst -, ,$(DEB_VERSION)))

# sets DEB_HOST_* variables
include /usr/share/dpkg/architecture.mk

# Ubuntu ld adds -Bsymbolic-functions by default, but that prevents FFmpeg from building.
export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions

# Package name for the extra flavor.
SHLIB_PKGS := $(shell sed -nr '/extra/! s/^Package:[[:space:]]*(lib.*[0-9]+)[[:space:]]*$$/\1/p' debian/control)
EXTRA_PKGS := $(shell sed -nr 's/^Package:[[:space:]]*(.*extra[0-9]+)[[:space:]]*$$/\1/p' debian/control)
FLAVORS = standard extra static

# Enable as many features as possible, as long as the result is still GPLv2+ (a GPLv3+ variant is built as libavcodec-extra/libavfilter-extra flavor).
# The following flags (and build-dependencies) are not added, because they would require a libavformat-extra flavor:
#   --enable-libsmbclient           (libsmbclient-dev [!hurd-i386 !m68k !sparc64])
# The following flags are not added, because the necessary libraries are not in Debian:
#   --enable-decklink
#   --enable-libcelt                (see #676592: removed from Debian as abandoned upstream, replaced by opus)
#   --enable-libdavs2
#   --enable-libilbc                (see #675959 for the RFP bug)
#   --enable-libklvanc
#   --enable-libkvazaar
#   --enable-libmfx
#   --enable-libopenh264
#   --enable-libsrt
#   --enable-libtensorflow          (only in experimental at the moment)
#   --enable-libvmaf
#   --enable-libxavs2
#   --enable-libxavs
#   --enable-libzimg                (see #864888 for the RFP bug)
#   --enable-vapoursynth            (see #833942 for the RFP bug)
# The following flags are not added for various reasons:
#   --enable-librtmp                ffmpeg has better built-in RTMP support with listen mode.
#   --enable-mbedtls                Already using gnutls as TLS implementation
#   --enable-libmodplug             see #849840: replaced with libopenmpt
#   --enable-libv4l2                This is only needed for very old devices and may cause problems for others.
#                                   Should anyone need it, using LD_PRELOAD pointing on libv4l2 has the same effect.
#   --enable-opencl                 This is considered an experimental API.
#   --enable-opencv                 Does not build with OpenCV >= 3.4
CONFIG := --prefix=/usr \
	--extra-version="$(DEB_REVISION)" \
	--toolchain=hardened \
	--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	--incdir=/usr/include/$(DEB_HOST_MULTIARCH) \
	--arch=$(DEB_HOST_ARCH_CPU) \
	--enable-gpl \
	--disable-stripping \
	--enable-avresample --disable-filter=resample \
	--enable-avisynth \
	--enable-gnutls \
	--enable-ladspa \
	--enable-libaom \
	--enable-libass \
	--enable-libbluray \
	--enable-libbs2b \
	--enable-libcaca \
	--enable-libcdio \
	--enable-libcodec2 \
	--enable-libflite \
	--enable-libfontconfig \
	--enable-libfreetype \
	--enable-libfribidi \
	--enable-libgme \
	--enable-libgsm \
	--enable-libjack \
	--enable-libmp3lame \
	--enable-libmysofa \
	--enable-libopenjpeg \
	--enable-libopenmpt \
	--enable-libopus \
	--enable-libpulse \
	--enable-librsvg \
	--enable-librubberband \
	--enable-libshine \
	--enable-libsnappy \
	--enable-libsoxr \
	--enable-libspeex \
	--enable-libssh \
	--enable-libtheora \
	--enable-libtwolame \
	--enable-libvidstab \
	--enable-libvorbis \
	--enable-libvpx \
	--enable-libwavpack \
	--enable-libwebp \
	--enable-libx265 \
	--enable-libxml2 \
	--enable-libxvid \
	--enable-libzmq \
	--enable-libzvbi \
	--enable-lv2 \
	--enable-omx \
        --enable-ftomx \
	--enable-openal \
	--enable-opengl \
	--enable-sdl2 \
	--enable-libdavs2 \
	--enable-libxavs2 \
	--enable-vaapi

ifeq ($(DEB_HOST_ARCH),amd64)
    CONFIG += --disable-asm \
        --disable-x86asm \
        --enable-cuda \
        --enable-cuvid \
        --enable-nvenc \
        --enable-nvdec \
        --enable-nonfree \
        --enable-libnpp
endif

# The standard configuration only uses the shared CONFIG.
CONFIG_standard = --enable-shared

# With these enabled, resulting binaries are effectively licensed as GPLv3+.
CONFIG_extra = --enable-shared \
	--enable-version3 \
	--disable-doc \
	--disable-programs \
	--enable-liblensfun \
	--enable-libopencore_amrnb \
	--enable-libopencore_amrwb \
	--enable-libtesseract \
	--enable-libvo_amrwbenc

# The static libraries should not be built with PIC.
CONFIG_static = --disable-pic \
	--disable-doc \
	--disable-programs

# Disable optimizations if requested.
ifneq (,$(filter $(DEB_BUILD_OPTIONS),noopt))
	CONFIG += --disable-optimizations
endif

# Respect CC/CXX from the environment, if they differ from the default.
# Don't set them if they equal the default, because that disables autodetection needed for cross-building.
ifneq ($(CC),cc)
	CONFIG += --cc=$(CC)
endif
ifneq ($(CXX),g++)
	CONFIG += --cxx=$(CXX)
endif

# Some libraries are built only on linux.
ifeq ($(DEB_HOST_ARCH_OS),linux)
	CONFIG += --enable-libdc1394 \
		--enable-libdrm \
		--enable-libiec61883
endif

# ffmpeg is involved in build-dependency cycles with x264 and chromaprint, so disable them in stage one.
# Also disable frei0r, which build-depends on opencv.
ifneq ($(filter pkg.ffmpeg.stage1,$(DEB_BUILD_PROFILES)),)
	CONFIG += --disable-frei0r \
		--disable-chromaprint \
		--disable-libx264
else
	CONFIG += --enable-chromaprint \
		--enable-frei0r \
		--enable-libx264
endif

# Disable altivec optimizations on powerpc, because they are not always available on this architecture.
ifeq ($(DEB_HOST_ARCH),powerpc)
	CONFIG += --disable-altivec
	# Build an altivec flavor of the libraries on powerpc.
	# This works around the problem that runtime cpu detection on powerpc currently does not work,
	# because, if altivec is enabled, all files are build with '-maltivec' so that the compiler inserts altivec instructions, wherever it likes.
	CONFIG_altivec = --enable-shared \
		--enable-altivec \
		--disable-doc \
		--disable-programs
	CONFIG_altivec-extra = $(CONFIG_altivec) $(CONFIG_extra)
	FLAVORS += altivec altivec-extra
endif

# Disable assembly optimizations on x32, because they don't work (yet).
ifneq (,$(filter $(DEB_HOST_ARCH),x32))
	CONFIG += --disable-asm
endif

# Disable some optimizations on mips*, because they are not always available on these architectures
ifneq (,$(filter mips%r6 mips%r6el, $(DEB_HOST_ARCH)))
	MIPS_R2_R6_CONFIG = --disable-mips32r2 \
		--disable-mips64r2
else
	MIPS_R2_R6_CONFIG = --disable-mips32r6 \
		--disable-mips64r6
endif

ifneq (,$(filter mips%, $(DEB_HOST_ARCH)))
	CONFIG += --disable-mipsdsp \
		--disable-mipsdspr2 \
		--disable-mips32r5 \
		--optflags="-O3 -mabi=64" \
		$(MIPS_R2_R6_CONFIG)
endif

# Disable mipsfpu on mips and mipsel, because it is not compatible with the FPXX ABI
#ifneq (,$(filter $(DEB_HOST_ARCH),mips mipsel))
#	CONFIG += --disable-mipsfpu
#endif

# Disable some tests which fail when FLT_EVAL_METHOD != 0 (found on i386, m68k and s390x)
ifneq (,$(filter $(DEB_HOST_ARCH_CPU),i386 m68k s390x))
	CONFIG += --ignore-tests=hapenc-hap-none,hapenc-hapa-none,hapenc-hapq-none
endif

# Set cross-build prefix for compiler, pkg-config...
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	CONFIG += --cross-prefix=$(DEB_HOST_GNU_TYPE)- \
		--target-os=$(DEB_HOST_ARCH_OS)
endif

# Use the default debhelper scripts, where possible.
%:
	dh $@

# Add configuration options:
override_dh_auto_configure:
	$(foreach flavor,$(FLAVORS),mkdir -p debian/$(flavor);)
	$(foreach flavor,$(FLAVORS),set -e; echo " *** $(flavor) ***"; cd debian/$(flavor); ../../configure $(CONFIG) $(CONFIG_$(flavor)) || (cat ffbuild/config.log && exit 1); cd ../.. ;)

# Remove the subdirectories generated for the flavors.
override_dh_auto_clean:
	$(foreach flavor,$(FLAVORS),[ ! -d debian/$(flavor) ] || rm -r debian/$(flavor);)

# Create doxygen documentation:
override_dh_auto_build-indep:

## ffmpeg 4.1.10

=== debian/changelog ===
ffmpeg (7:4.1.10-0+deb10u1) buster-security; urgency=medium

  * Non-maintainer upload by the LTS Security Team.
  * New upstream release.

 -- Sylvain Beucler <beuc@debian.org>  Thu, 03 Nov 2022 17:11:47 +0100
